module ThePrelude(preludeAndStdLibs) where

preludeAndStdLibs :: [String]
preludeAndStdLibs = [array_,char_,complex_,cputime_,directory_,io_,ix_,list_,locale_,maybe_,monad_,numeric_,prelude_,random_,ratio_,system_,time_]

array_ = "module Array(module Ix) where\n\nimport Ix\n"

char_ = "module Char where\n"

complex_ = "module Complex where\n"

cputime_ = "module CPUTime where\n"

directory_ = "module Directory where\n"

io_ = "module IO where\n"

ix_ = "module Ix where\n\nclass  (Ord a) => Ix a  where\n     range               :: (a,a) -> [a]\n     index               :: (a,a) -> a -> Int\n     inRange             :: (a,a) -> a -> Bool\n"

list_ = "module List where\n"

locale_ = "module Locale where\n"

maybe_ = "module Maybe where\n"

monad_ = "module Monad where\n\nclass  Monad m => MonadPlus m  where\n     mzero  :: m a\n     mplus  :: m a -> m a -> m a\n"

numeric_ = "module Numeric where\n"

prelude_ = "module Prelude where\n\nclass  Eq a  where\n    (==), (/=)       :: a -> a -> Bool\n\nclass  (Eq a) => Ord a  where\n    compare              :: a -> a -> Ordering\n    (<), (<=), (>=), (>) :: a -> a -> Bool\n    max, min             :: a -> a -> a\n\nclass  Enum a  where\n    succ, pred       :: a -> a\n    toEnum           :: Int -> a\n    fromEnum         :: a -> Int\n    enumFrom         :: a -> [a]             -- [n..]\n    enumFromThen     :: a -> a -> [a]        -- [n,n'..]\n    enumFromTo       :: a -> a -> [a]        -- [n..m]\n    enumFromThenTo   :: a -> a -> a -> [a]   -- [n,n'..m]\n\n\nclass  Bounded a  where\n    minBound         :: a\n    maxBound         :: a\n\nclass  (Eq a, Show a) => Num a  where\n    (+), (-), (*)    :: a -> a -> a\n    negate           :: a -> a\n    abs, signum      :: a -> a\n    fromInteger      :: Integer -> a\n\nclass  (Num a, Ord a) => Real a  where\n    toRational       ::  a -> Rational\n\nclass  (Real a, Enum a) => Integral a  where\n    quot, rem        :: a -> a -> a   \n    div, mod         :: a -> a -> a\n    quotRem, divMod  :: a -> a -> (a,a)\n    toInteger        :: a -> Integer\n\nclass  (Num a) => Fractional a  where\n    (/)              :: a -> a -> a\n    recip            :: a -> a\n    fromRational     :: Rational -> a\n\nclass  (Fractional a) => Floating a  where\n    pi                  :: a\n    exp, log, sqrt      :: a -> a\n    (**), logBase       :: a -> a -> a\n    sin, cos, tan       :: a -> a\n    asin, acos, atan    :: a -> a\n    sinh, cosh, tanh    :: a -> a\n    asinh, acosh, atanh :: a -> a\n\nclass  (Real a, Fractional a) => RealFrac a  where\n    properFraction   :: (Integral b) => a -> (b,a)\n    truncate, round  :: (Integral b) => a -> b\n    ceiling, floor   :: (Integral b) => a -> b\n\nclass  (RealFrac a, Floating a) => RealFloat a  where\n    floatRadix       :: a -> Integer\n    floatDigits      :: a -> Int\n    floatRange       :: a -> (Int,Int)\n    decodeFloat      :: a -> (Integer,Int)\n    encodeFloat      :: Integer -> Int -> a\n    exponent         :: a -> Int\n    significand      :: a -> a\n    scaleFloat       :: Int -> a -> a\n    isNaN, isInfinite, isDenormalized, isNegativeZero, isIEEE :: a -> Bool\n    atan2            :: a -> a -> a\n\nclass  Functor f  where\n    fmap              :: (a -> b) -> f a -> f b\n\nclass  Monad m  where\n    (>>=)  :: m a -> (a -> m b) -> m b\n    (>>)   :: m a -> m b -> m b\n    return :: a -> m a\n    fail   :: String -> m a\n\nclass  Read a  where\n    readsPrec        :: Int -> ReadS a\n    readList         :: ReadS [a]\n\nclass  Show a  where\n    showsPrec        :: Int -> a -> ShowS\n    show       :: a -> String \n    showList         :: [a] -> ShowS\n"

random_ = "module Random where\n\nclass RandomGen g where\n   next  :: g  -> (Int, g)\n   split :: g -> (g, g)\n\nclass Random a where\n    randomR :: RandomGen g => (a, a) -> g -> (a, g)\n    random  :: RandomGen g => g -> (a, g)\n\n    randomRs :: RandomGen g => (a, a) -> g -> [a]\n    randoms  :: RandomGen g => g -> [a]\n\n    randomRIO :: (a,a) -> IO a\n    randomIO  :: IO a\n"

ratio_ = "module Ratio where\n"

system_ = "module System where\n"

time_ = "module Time where\n"

